<?php
/**
 * @copyright      Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license        GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die();

jimport('joomla.plugin.plugin');
jimport('joomla.application.component.model');
jimport('database.table');

class plgSystemEautopay extends JPlugin
{

	function onAfterInitialise()
	{
		if(JFactory::getApplication()->isAdmin())
		{
			return;
		}

		$secretkey = $this->params->get('secret');;
		$con = $this->params->get('conversion');
		$con = explode("\n", str_replace("\r", "", $con));
		foreach($con as $cond)
		{
			if(!trim($cond))
			{
				continue;
			}
			$array                 = explode("**", $cond);
			$conversion[$array[0]] = $array[1];
		}

		if(!$secretkey || !$conversion)
		{
			JError::raiseWarning(100, 'Вы активировали интегрицию e-autopay и Emerald но не настроили ее. Пожалуйста или отключите этот плагин или зайдите в настнойки и заполните нужные поля.');

			return;
		}

		require_once JPATH_ROOT . '/components/com_emerald/api.php';

		$post = $_POST;

		if(empty($post['product_id']) || empty($post['email']) || empty($post['hash']))
		{
			return;
		}

		$this->_log("secret: " . $secretkey);
		$this->_log("conversion: " . print_r($conversion, TRUE));
		$this->_log("post: " . print_r($post, TRUE));

		$key = md5($post['id'] . $post['email'] . $post['phone'] . $secretkey);

		if($key != $post['hash'])
		{
			$this->_log("Does not match");
			echo 'What?!!! Back off!';
			JFactory::getApplication()->close();

			return;
		}

		$fname = $post['first_name'];
		$lname = $post['last_name'];
		$email = $post['email'];

		$db = JFactory::getDbo();
		$db->setQuery("SELECT * FROM #__users WHERE email = '{$email}'");
		$user = $db->loadObject();

		if(!$user)
		{
			$login = substr($email, 0, strpos($email, '@'));

			$db->setQuery("SELECT id FROM #__users WHERE username = '" . $db->escape($login) . "'");
			$user = $db->loadObject();
			if(!empty($user->id))
			{
				$login = $login + $user->id;
			}

			$pwd = substr(md5($email . $fname . time()), 0, 6);

			$data['name']      = $fname . ' ' . $lname;
			$data['username']  = $login;
			$data['email1']    = $email;
			$data['email2']    = $email;
			$data['password1'] = $pwd;
			$data['password2'] = $pwd;

			JFactory::getLanguage()->load('com_users');

			JModelLegacy::addIncludePath(JPATH_ROOT . '/components/com_users/models');
			$model = JModelLegacy::getInstance('Registration', 'UsersModel');
			$return = $model->register($data);

			$this->_log("new user: " . print_r($data, TRUE));

			//$db->setQuery("UPDATE #__users SET `block` = 0, `activation` = '' WHERE email = '{$email}'");
			//$db->query();
		}

		$db->setQuery("SELECT * FROM #__users WHERE email = '{$email}'");
		$user = $db->loadObject();


		if(empty($conversion[$post['product_id']]))
		{
			$this->_log("This product not found in conversion array");

			return;
		}

		$plans = explode(',', $conversion[$post['product_id']]);
		foreach($plans as $plan_id)
		{
			$plan_id = (int)$plan_id;
			if(!$plan_id)
			{
				continue;
			}

			$plan = EmeraldApi::getPreparedPlan($plan_id);
			if(empty($plan->id))
			{
				continue;
			}


			$this->_log("plan: " . $plan_id);

			if(EmeraldApi::addSubscription($user->id, $plan_id, 1, 'E-Autopay', $post['product_price'], $post['id'] . ':' . $post['product_id']))
			{
				$this->_close('Ok');
			}
			else
			{
				$this->_log('Could not save.');
			}
		}
		$this->_close('Nothing');
	}

	private function _log($msg)
	{
		if(!$this->params->get('log', 1))
		{
			return;
		}
		error_log("\n" . $msg, 3, JPATH_ROOT . '/logs/log.txt');
	}

	private function _close($msg)
	{
		echo json_encode(array(
							  'message' => $msg
						 ));
		JFactory::getApplication()->close();
	}
}
